searchNodes=[{"doc":"","ref":"Exq.html","title":"Exq","type":"module"},{"doc":"","ref":"Exq.html#child_spec/1","title":"Exq.child_spec/1","type":"function"},{"doc":"Enqueue a job immediately.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queue to useworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer, jid: String]Returns:{:ok, jid} if the job was enqueued successfully, with jid = Job ID.{:error, reason} if there was an error enqueueing job","ref":"Exq.html#enqueue/4","title":"Exq.enqueue/4","type":"function"},{"doc":"","ref":"Exq.html#enqueue/5","title":"Exq.enqueue/5","type":"function"},{"doc":"Schedule a job to be enqueued at a specific time in the future.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - name of queue to usetime - Time to enqueueworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer, jid: String]If Exq is running in mode: [:enqueuer], then you will need to use the Enqueuer to schedule jobs, for example:time = Timex.now() |&gt; Timex.shift(days: 8) Exq.Enqueuer.enqueue_at(Exq.Enqueuer, &quot;default&quot;, time, MyWorker, [&quot;foo&quot;])","ref":"Exq.html#enqueue_at/5","title":"Exq.enqueue_at/5","type":"function"},{"doc":"","ref":"Exq.html#enqueue_at/6","title":"Exq.enqueue_at/6","type":"function"},{"doc":"Schedule a job to be enqueued at in the future given by offset in seconds.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queue to useoffset - Offset in seconds in the future to enqueueworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer]If Exq is running in mode: [:enqueuer], then you will need to use the Enqueuer to schedule jobs, for example:Exq.Enqueuer.enqueue_in(Exq.Enqueuer, &quot;default&quot;, 5000, MyWorker, [&quot;foo&quot;])","ref":"Exq.html#enqueue_in/5","title":"Exq.enqueue_in/5","type":"function"},{"doc":"","ref":"Exq.html#enqueue_in/6","title":"Exq.enqueue_in/6","type":"function"},{"doc":"Callback implementation for Application.start/2.","ref":"Exq.html#start/2","title":"Exq.start/2","type":"function"},{"doc":"","ref":"Exq.html#start_link/1","title":"Exq.start_link/1","type":"function"},{"doc":"Subscribe to a queue - ie. listen to queue for jobspid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queueconcurrency - Optional argument specifying max concurrency for queue","ref":"Exq.html#subscribe/2","title":"Exq.subscribe/2","type":"function"},{"doc":"","ref":"Exq.html#subscribe/3","title":"Exq.subscribe/3","type":"function"},{"doc":"List all subscriptions(active queues)pid - PID for Exq Manager or Enqueuer to handle this","ref":"Exq.html#subscriptions/1","title":"Exq.subscriptions/1","type":"function"},{"doc":"Unsubscribe from a queue - ie. stop listening to queue for jobspid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queue","ref":"Exq.html#unsubscribe/2","title":"Exq.unsubscribe/2","type":"function"},{"doc":"Unsubscribe from all queues - ie. stop listening for jobspid - PID for Exq Manager or Enqueuer to handle this","ref":"Exq.html#unsubscribe_all/1","title":"Exq.unsubscribe_all/1","type":"function"},{"doc":"","ref":"Exq.html#whereis/1","title":"Exq.whereis/1","type":"function"},{"doc":"Get the job metadataname - registered name of Exq. Only necessary if the custom name option is used when starting Exq. Defaults to Exqpid - pid of the worker. Defaults to self().","ref":"Exq.html#worker_job/2","title":"Exq.worker_job/2","type":"function"},{"doc":"Behaviour for creating Exq queue adapters.Exampledefmodule Exq.Adapters.Queue.CustomAdapter do @behaviour Exq.Adapters.Queue def enqueue(pid, queue, worker, args, options) do {:ok, apply(worker, :perform, args)} end def enqueue_at(pid, queue, time, worker, args, options) do enqueue_somehow(pid, queue, time, worker, args, options) end def enqueue_in(pid, queue, offset, worker, args, options) do enqueue_in_somehow(pid, queue, offset, worker, args, options) end end","ref":"Exq.Adapters.Queue.html","title":"Exq.Adapters.Queue","type":"behaviour"},{"doc":"","ref":"Exq.Adapters.Queue.html#c:enqueue/5","title":"Exq.Adapters.Queue.enqueue/5","type":"callback"},{"doc":"","ref":"Exq.Adapters.Queue.html#c:enqueue_at/6","title":"Exq.Adapters.Queue.enqueue_at/6","type":"callback"},{"doc":"","ref":"Exq.Adapters.Queue.html#c:enqueue_in/6","title":"Exq.Adapters.Queue.enqueue_in/6","type":"callback"},{"doc":"The GenServer name","ref":"Exq.Adapters.Queue.html#t:name/0","title":"Exq.Adapters.Queue.name/0","type":"type"},{"doc":"The server reference","ref":"Exq.Adapters.Queue.html#t:server/0","title":"Exq.Adapters.Queue.server/0","type":"type"},{"doc":"Mock queue.Designed to be used when testing your application.","ref":"Exq.Adapters.Queue.Mock.html","title":"Exq.Adapters.Queue.Mock","type":"module"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue/5.","ref":"Exq.Adapters.Queue.Mock.html#enqueue/5","title":"Exq.Adapters.Queue.Mock.enqueue/5","type":"function"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue_at/6.","ref":"Exq.Adapters.Queue.Mock.html#enqueue_at/6","title":"Exq.Adapters.Queue.Mock.enqueue_at/6","type":"function"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue_in/6.","ref":"Exq.Adapters.Queue.Mock.html#enqueue_in/6","title":"Exq.Adapters.Queue.Mock.enqueue_in/6","type":"function"},{"doc":"Redis based Asynchronous queue.Enqueue the job by using the GenServer API. Default queue. Designed to be used in production.","ref":"Exq.Adapters.Queue.Redis.html","title":"Exq.Adapters.Queue.Redis","type":"module"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue/5.","ref":"Exq.Adapters.Queue.Redis.html#enqueue/5","title":"Exq.Adapters.Queue.Redis.enqueue/5","type":"function"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue_at/6.","ref":"Exq.Adapters.Queue.Redis.html#enqueue_at/6","title":"Exq.Adapters.Queue.Redis.enqueue_at/6","type":"function"},{"doc":"Callback implementation for Exq.Adapters.Queue.enqueue_in/6.","ref":"Exq.Adapters.Queue.Redis.html#enqueue_in/6","title":"Exq.Adapters.Queue.Redis.enqueue_in/6","type":"function"},{"doc":"Interface for retrieving Exq stats.Pid is currently Exq.Api process.","ref":"Exq.Api.html","title":"Exq.Api","type":"module"},{"doc":"Number of busy workersExpected args:pid - Exq.Api processReturns:{:ok, num_busy} - number of busy workers","ref":"Exq.Api.html#busy/1","title":"Exq.Api.busy/1","type":"function"},{"doc":"","ref":"Exq.Api.html#clear_failed/1","title":"Exq.Api.clear_failed/1","type":"function"},{"doc":"","ref":"Exq.Api.html#clear_processes/1","title":"Exq.Api.clear_processes/1","type":"function"},{"doc":"","ref":"Exq.Api.html#clear_retries/1","title":"Exq.Api.clear_retries/1","type":"function"},{"doc":"","ref":"Exq.Api.html#clear_scheduled/1","title":"Exq.Api.clear_scheduled/1","type":"function"},{"doc":"Re Enqueue jobs from dead queue.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns:{:ok, num_enqueued}","ref":"Exq.Api.html#dequeue_failed_jobs/2","title":"Exq.Api.dequeue_failed_jobs/2","type":"function"},{"doc":"Re enqueue jobs from retry queue immediatly.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns:{:ok, num_enqueued}","ref":"Exq.Api.html#dequeue_retry_jobs/2","title":"Exq.Api.dequeue_retry_jobs/2","type":"function"},{"doc":"Enqueue jobs from scheduled queue immediatly.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns:{:ok, num_enqueued}","ref":"Exq.Api.html#dequeue_scheduled_jobs/2","title":"Exq.Api.dequeue_scheduled_jobs/2","type":"function"},{"doc":"List jobs that have failed and will not retry, as they've exceeded their retry count.Expected args:pid - Exq.Api processoptionsscore: (boolean) whether to include job scoresize: (integer) size of listoffset: (integer) start offset of the listReturns:{:ok, [jobs]}","ref":"Exq.Api.html#failed/2","title":"Exq.Api.failed/2","type":"function"},{"doc":"Number of jobs that have failed and exceeded their retry count.Expected args:pid - Exq.Api processReturns:{:ok, num_failed} - number of failed jobs","ref":"Exq.Api.html#failed_size/1","title":"Exq.Api.failed_size/1","type":"function"},{"doc":"","ref":"Exq.Api.html#find_failed/2","title":"Exq.Api.find_failed/2","type":"function"},{"doc":"Find failed jobExpected args:pid - Exq.Api processscore - Job scorejid - Job jidoptionsraw: (boolean) whether to deserialize the jobReturns:{:ok, job}","ref":"Exq.Api.html#find_failed/4","title":"Exq.Api.find_failed/4","type":"function"},{"doc":"","ref":"Exq.Api.html#find_job/3","title":"Exq.Api.find_job/3","type":"function"},{"doc":"","ref":"Exq.Api.html#find_retry/2","title":"Exq.Api.find_retry/2","type":"function"},{"doc":"Find job in retry queueExpected args:pid - Exq.Api processscore - Job scorejid - Job jidoptionsraw: (boolean) whether to deserialize the jobReturns:{:ok, job}","ref":"Exq.Api.html#find_retry/4","title":"Exq.Api.find_retry/4","type":"function"},{"doc":"","ref":"Exq.Api.html#find_scheduled/2","title":"Exq.Api.find_scheduled/2","type":"function"},{"doc":"Find job in scheduled queueExpected args:pid - Exq.Api processscore - Job scorejid - Job jidoptionsraw: (boolean) whether to deserialize the jobReturns:{:ok, job}","ref":"Exq.Api.html#find_scheduled/4","title":"Exq.Api.find_scheduled/4","type":"function"},{"doc":"List jobs enqueuedExpected args:pid - Exq.Api processReturns:{:ok, [{queue, [jobs]}, {queue, [jobs]}]}","ref":"Exq.Api.html#jobs/1","title":"Exq.Api.jobs/1","type":"function"},{"doc":"List jobs enqueuedExpected args:pid - Exq.Api processqueue - Queue nameoptionssize: (integer) size of listoffset: (integer) start offset of the listraw: (boolean) whether to deserialize the jobReturns:{:ok, [jobs]}","ref":"Exq.Api.html#jobs/3","title":"Exq.Api.jobs/3","type":"function"},{"doc":"List of worker nodes currently running","ref":"Exq.Api.html#nodes/1","title":"Exq.Api.nodes/1","type":"function"},{"doc":"List of processes currently runningExpected args:pid - Exq.Api processReturns:{:ok, [processes]}","ref":"Exq.Api.html#processes/1","title":"Exq.Api.processes/1","type":"function"},{"doc":"A count of the number of jobs in the queue, for each queue.Expected args:pid - Exq.Api processReturns:{:ok, [{queue, num_jobs}, {queue, num_jobs}]}","ref":"Exq.Api.html#queue_size/1","title":"Exq.Api.queue_size/1","type":"function"},{"doc":"A count of the number of jobs in the queue, for a provided queue.Expected args:pid - Exq.Api processqueue - The name of the queue to find the number of jobs forReturns:{:ok, num_jobs}","ref":"Exq.Api.html#queue_size/2","title":"Exq.Api.queue_size/2","type":"function"},{"doc":"List of queues with jobs (empty queues are deleted).Expected args:pid - Exq.Api processReturns:{:ok, queues} - list of queue","ref":"Exq.Api.html#queues/1","title":"Exq.Api.queues/1","type":"function"},{"doc":"","ref":"Exq.Api.html#realtime_stats/1","title":"Exq.Api.realtime_stats/1","type":"function"},{"doc":"Removes a job from the queue specified.Expected args:pid - Exq.Api processqueue - The name of the queue to remove the job fromraw_job - raw json encoded job valueReturns::ok","ref":"Exq.Api.html#remove_enqueued_jobs/3","title":"Exq.Api.remove_enqueued_jobs/3","type":"function"},{"doc":"Removes a job in the queue of jobs that have failed and exceeded their retry count.Expected args:pid - Exq.Api processjid - Unique identifier for the jobReturns::ok","ref":"Exq.Api.html#remove_failed/2","title":"Exq.Api.remove_failed/2","type":"function"},{"doc":"Removes jobs from dead queue.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns::ok","ref":"Exq.Api.html#remove_failed_jobs/2","title":"Exq.Api.remove_failed_jobs/2","type":"function"},{"doc":"Removes a job from the queue specified.Expected args:pid - Exq.Api processqueue - The name of the queue to remove the job fromjid - Unique identifier for the jobReturns::ok","ref":"Exq.Api.html#remove_job/3","title":"Exq.Api.remove_job/3","type":"function"},{"doc":"Clear / Remove queueExpected args:pid - Exq.Api processqueue - Queue nameReturns:{:ok, queues} - list of queue","ref":"Exq.Api.html#remove_queue/2","title":"Exq.Api.remove_queue/2","type":"function"},{"doc":"Removes a job in the retry queue from being enqueued again.Expected args:pid - Exq.Api processjid - Unique identifier for the jobReturns::ok","ref":"Exq.Api.html#remove_retry/2","title":"Exq.Api.remove_retry/2","type":"function"},{"doc":"Removes jobs from retry queue.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns::ok","ref":"Exq.Api.html#remove_retry_jobs/2","title":"Exq.Api.remove_retry_jobs/2","type":"function"},{"doc":"Removes a job scheduled to run in the future from being enqueued.Expected args:pid - Exq.Api processjid - Unique identifier for the jobReturns::ok","ref":"Exq.Api.html#remove_scheduled/2","title":"Exq.Api.remove_scheduled/2","type":"function"},{"doc":"Removes jobs from scheduled queue.Expected args:pid - Exq.Api processraw_job - raw json encoded job valueReturns::ok","ref":"Exq.Api.html#remove_scheduled_jobs/2","title":"Exq.Api.remove_scheduled_jobs/2","type":"function"},{"doc":"List jobs that will be retried because they previously failed and have not exceeded their retry_count.Expected args:pid - Exq.Api processoptionsscore: (boolean) whether to include job scoresize: (integer) size of listoffset: (integer) start offset of the listReturns:{:ok, [jobs]}","ref":"Exq.Api.html#retries/2","title":"Exq.Api.retries/2","type":"function"},{"doc":"","ref":"Exq.Api.html#retry_job/2","title":"Exq.Api.retry_job/2","type":"function"},{"doc":"Number of jobs in the retry queue.Expected args:pid - Exq.Api processReturns:{:ok, num_retry} - number of jobs to be retried","ref":"Exq.Api.html#retry_size/1","title":"Exq.Api.retry_size/1","type":"function"},{"doc":"List jobs that are enqueued and scheduled to be run at a future time.Expected args:pid - Exq.Api processoptionsscore: (boolean) whether to include job scoresize: (integer) size of listoffset: (integer) start offset of the listReturns:{:ok, [jobs]}","ref":"Exq.Api.html#scheduled/2","title":"Exq.Api.scheduled/2","type":"function"},{"doc":"Number of scheduled jobs enqueued.Expected args:pid - Exq.Api processReturns:{:ok, num_scheduled} - number of scheduled jobs enqueued","ref":"Exq.Api.html#scheduled_size/1","title":"Exq.Api.scheduled_size/1","type":"function"},{"doc":"List jobs that are enqueued and scheduled to be run at a future time, along with when they are scheduled to run.Expected args:pid - Exq.Api processReturns:{:ok, [{job, scheduled_at}]}","ref":"Exq.Api.html#scheduled_with_scores/1","title":"Exq.Api.scheduled_with_scores/1","type":"function"},{"doc":"","ref":"Exq.Api.html#start_link/1","title":"Exq.Api.start_link/1","type":"function"},{"doc":"Return stat for given key.Examples of keys are processed and failed.Expected args:pid - Exq.Api processkey - Key for statqueue - Queue nameReturns:{:ok, stat} stat for key","ref":"Exq.Api.html#stats/2","title":"Exq.Api.stats/2","type":"function"},{"doc":"","ref":"Exq.Api.html#stats/3","title":"Exq.Api.stats/3","type":"function"},{"doc":"The API deals with getting current stats for the UI / API.","ref":"Exq.Api.Server.html","title":"Exq.Api.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Api.Server.html#child_spec/1","title":"Exq.Api.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Api.Server.html#init/1","title":"Exq.Api.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Api.Server.html#server_name/1","title":"Exq.Api.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.Api.Server.html#start_link/1","title":"Exq.Api.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Api.Server.State.html","title":"Exq.Api.Server.State","type":"module"},{"doc":"","ref":"Exq.Backoff.Behaviour.html","title":"Exq.Backoff.Behaviour","type":"behaviour"},{"doc":"","ref":"Exq.Backoff.Behaviour.html#c:offset/1","title":"Exq.Backoff.Behaviour.offset/1","type":"callback"},{"doc":"","ref":"Exq.Backoff.SidekiqDefault.html","title":"Exq.Backoff.SidekiqDefault","type":"module"},{"doc":"Callback implementation for Exq.Backoff.Behaviour.offset/1.","ref":"Exq.Backoff.SidekiqDefault.html#offset/1","title":"Exq.Backoff.SidekiqDefault.offset/1","type":"function"},{"doc":"Custom concurrency or rate limiting at a queue level can be achieved by implementing the Dequeue behaviour.The following config can be used to customize dequeue behaviour for a queue:config :exq, queues: [{&quot;default&quot;, {RateLimiter, options}}]RateLimiter module should implement Exq.Dequeue.Behaviour. The options supplied here would be passed as the second argument to the init/2 function.Life cycleinit/2 will be invoked on initialization. The first argument will contain info like queue and the second argument is user configurable.available?/1 will be invoked before each poll. If the returned value contains false as the second element of the tuple, the queue will not polleddispatched/1 will be invoked once a job is dispatched to the workerprocessed/1 will be invoked if a job completed successfullyfailed/1 will be invoked if a job failedstop/1 will be invoked when a queue is unsubscribed or before the node terminates. Note: there is no guarantee this will be invoked if the node terminates abruptly","ref":"Exq.Dequeue.Behaviour.html","title":"Exq.Dequeue.Behaviour","type":"behaviour"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:available?/1","title":"Exq.Dequeue.Behaviour.available?/1","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:dispatched/1","title":"Exq.Dequeue.Behaviour.dispatched/1","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:failed/1","title":"Exq.Dequeue.Behaviour.failed/1","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:init/2","title":"Exq.Dequeue.Behaviour.init/2","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:processed/1","title":"Exq.Dequeue.Behaviour.processed/1","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Behaviour.html#c:stop/1","title":"Exq.Dequeue.Behaviour.stop/1","type":"callback"},{"doc":"","ref":"Exq.Dequeue.Local.html","title":"Exq.Dequeue.Local","type":"module"},{"doc":"Enqueuer.","ref":"Exq.Enqueuer.html","title":"Exq.Enqueuer","type":"module"},{"doc":"Enqueue a job immediately.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queue to useworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer, jid: String]Returns:{:ok, jid} if the job was enqueued successfully, with jid = Job ID.{:error, reason} if there was an error enqueueing job","ref":"Exq.Enqueuer.html#enqueue/4","title":"Exq.Enqueuer.enqueue/4","type":"function"},{"doc":"","ref":"Exq.Enqueuer.html#enqueue/5","title":"Exq.Enqueuer.enqueue/5","type":"function"},{"doc":"Schedule a job to be enqueued at a specific time in the future.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - name of queue to usetime - Time to enqueueworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer, jid: String]If Exq is running in mode: [:enqueuer], then you will need to use the Enqueuer to schedule jobs, for example:time = Timex.now() |&gt; Timex.shift(days: 8) Exq.Enqueuer.enqueue_at(Exq.Enqueuer, &quot;default&quot;, time, MyWorker, [&quot;foo&quot;])","ref":"Exq.Enqueuer.html#enqueue_at/5","title":"Exq.Enqueuer.enqueue_at/5","type":"function"},{"doc":"","ref":"Exq.Enqueuer.html#enqueue_at/6","title":"Exq.Enqueuer.enqueue_at/6","type":"function"},{"doc":"Schedule a job to be enqueued at in the future given by offset in seconds.Expected args:pid - PID for Exq Manager or Enqueuer to handle thisqueue - Name of queue to useoffset - Offset in seconds in the future to enqueueworker - Worker module to targetargs - Array of args to send to workeroptions - job options, for example [max_retries: Integer]If Exq is running in mode: [:enqueuer], then you will need to use the Enqueuer to schedule jobs, for example:Exq.Enqueuer.enqueue_in(Exq.Enqueuer, &quot;default&quot;, 5000, MyWorker, [&quot;foo&quot;])","ref":"Exq.Enqueuer.html#enqueue_in/5","title":"Exq.Enqueuer.enqueue_in/5","type":"function"},{"doc":"","ref":"Exq.Enqueuer.html#enqueue_in/6","title":"Exq.Enqueuer.enqueue_in/6","type":"function"},{"doc":"","ref":"Exq.Enqueuer.html#start_link/1","title":"Exq.Enqueuer.start_link/1","type":"function"},{"doc":"Enqueue API.Expects a Exq.Manager.Server or Exq.Enqueuer.Server process as first arg.","ref":"Exq.Enqueuer.EnqueueApi.html","title":"Exq.Enqueuer.EnqueueApi","type":"module"},{"doc":"The Enqueuer is responsible for enqueueing jobs into Redis.It can either be called directly by the client, or instantiated as a standalone process.It supports enqueuing immediate jobs, or scheduling jobs in the future.Initialization::name - Name of target registered process:namespace - Redis namespace to store all data under. Defaults to &quot;exq&quot;.:queues - Array of currently active queues (TODO: Remove, I suspect it's not needed).:redis - pid of Redis process.:scheduler_poll_timeout - How often to poll Redis for scheduled / retry jobs.","ref":"Exq.Enqueuer.Server.html","title":"Exq.Enqueuer.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Enqueuer.Server.html#child_spec/1","title":"Exq.Enqueuer.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Enqueuer.Server.html#init/1","title":"Exq.Enqueuer.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Enqueuer.Server.html#server_name/1","title":"Exq.Enqueuer.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.Enqueuer.Server.html#start_link/1","title":"Exq.Enqueuer.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Enqueuer.Server.State.html","title":"Exq.Enqueuer.Server.State","type":"module"},{"doc":"","ref":"Exq.Heartbeat.Monitor.html","title":"Exq.Heartbeat.Monitor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Heartbeat.Monitor.html#child_spec/1","title":"Exq.Heartbeat.Monitor.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Heartbeat.Monitor.html#init/1","title":"Exq.Heartbeat.Monitor.init/1","type":"function"},{"doc":"","ref":"Exq.Heartbeat.Monitor.html#start_link/1","title":"Exq.Heartbeat.Monitor.start_link/1","type":"function"},{"doc":"","ref":"Exq.Heartbeat.Monitor.State.html","title":"Exq.Heartbeat.Monitor.State","type":"module"},{"doc":"","ref":"Exq.Heartbeat.Server.html","title":"Exq.Heartbeat.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Heartbeat.Server.html#child_spec/1","title":"Exq.Heartbeat.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Heartbeat.Server.html#init/1","title":"Exq.Heartbeat.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Heartbeat.Server.html#start_link/1","title":"Exq.Heartbeat.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Heartbeat.Server.State.html","title":"Exq.Heartbeat.Server.State","type":"module"},{"doc":"The Manager module is the main orchestrator for the system.It is also the entry point Pid process used by the client to interact with the Exq system.It's responsibilities include:Handle interaction with client and delegate to responsible sub-systemInitial Setup of Redis Connection (to be moved to supervisor?).Setup and tracking of in-progress workers / jobs.Poll Redis for new jobs for any queues that have available workers.Handling of queue state and subscriptions (addition and removal)Initial re-hydration of backup queue on system restart to handle any orphan jobs from last system stop.The Manager is a GenServer with a timed process loop.Options:concurrency - Default max number of workers to use if not passed in for each queue.:genserver_timeout - Timeout to use for GenServer calls.:max_retries - Maximum number of times to retry a failed job:name - Name of target registered process:namespace - Redis namespace to store all data under. Defaults to &quot;exq&quot;.:queues - List of queues to monitor. Can be an array of queues names such as [&quot;q1&quot;, &quot;q2&quot;], or array of tuples with queue and max number of concurrent workers: [{&quot;q1&quot;, 1}, {&quot;q2&quot;, 20}]. If only an array is passed in, system will use the default concurrency value for each queue.:redis_timeout - Timeout to use for Redis commands.:poll_timeout - How often to poll Redis for jobs.:scheduler_enable - Whether scheduler / retry process should be enabled. This defaults to true. Note that is you turn this off, job retries will not be enqueued.:scheduler_poll_timeout - How often to poll Redis for scheduled / retry jobs.:shutdown_timeout - The number of milliseconds to wait for workers to finish processing jobs when the application is shutting downRedis Options (TODO - move to supervisor after refactor)::host - Host name for Redis server (defaults to '127.0.0.1'):port - Redis port (defaults to 6379):database - Redis Database number (used for isolation. Defaults to 0).:password - Redis authentication password (optional, off by default).:redis_options - Additional options provided to RedixTODO: What about max_reconnection_attemptsJob lifecycleThe job lifecycle starts with an enqueue of a job. This can be done either via Exq or another system like Sidekiq / Resque.Note that the JobQueue encapsulates much of this logic.Client (Exq) -&gt; Manager -&gt; EnqueuerAssuming Exq is used to Enqueue an immediate job, the following is the flow:Client calls Exq.enqueue(Exq, &quot;queue_name&quot;, Worker, [&quot;arg1&quot;, &quot;arg2&quot;])Manager delegates to EnqueuerEnqueuer does the following:Adds the queue to the &quot;queues&quot; list if not already there.Prepare a job struct with a generated UUID and convert to JSON.Push the job into the correct queueRespond to client with the generated job UUID.At this point the job is in the correct queue ready to be dequeued.Manager deq Redis -&gt; Worker (decode &amp; execute job) --&gt; Manager (record) | --&gt; Stats (record stats)The dequeueing of the job is as follows:The Manager is on a polling cycle, and the :timeout message fires.Manager tabulates a list of active queues with available workers.Uses the JobQueue module to fetch jobs. The JobQueue module does this through a single MULT RPOPLPUSH command issued to Redis with the targeted queue.This command atomically pops an item off the queue and stores the item in a backup queue. The backup queue is keyed off the queue and node id, so each node would have their own backup queue. Note that we cannot use a blocking pop since BRPOPLPUSH (unlike BRPOP) is more limited and can only handle a single queue target (see filed issues in Redis / Sidekiq).Once the jobs are returned to the manager, the manager goes through each job and creates and kicks off an ephemeral Worker process that will handle the job. The manager also does some tabulation to reduce the worker count for those queues.The worker parses the JSON object, and figures out the worker to call. It also tells Stats to record a itself in process.The worker then calls &quot;apply&quot; on the correct target module, and tracks the failure or success of the job. Once the job is finished, it tells the Manager and Stats.If the job is successful, Manager and Stats simply mark the success of the job.If the job fails, the Worker module uses the JobQueue module to retry the job if necessary. The retry is done by adding the job to a &quot;retry&quot; queue which is a Sorted Set in Redis. The job is marked with the retry count and scheduled date (using exponential backup). The job is then removed from the backup queue.If any jobs were fetched from Redis, the Manager will poll again immediately, otherwise if will use the poll_timeout for the next polling.Retry / Schedule queueThe retry / schedule queue provides functionality for scheduled jobs. This is used both for the enqueue_in method which allows a scheduled job in the future, as well as retry queue, which is used to retry jobs.","ref":"Exq.Manager.Server.html","title":"Exq.Manager.Server","type":"module"},{"doc":"Returns list of active queues with free workers","ref":"Exq.Manager.Server.html#available_queues/1","title":"Exq.Manager.Server.available_queues/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Manager.Server.html#child_spec/1","title":"Exq.Manager.Server.child_spec/1","type":"function"},{"doc":"Dequeue jobs and dispatch to workers","ref":"Exq.Manager.Server.html#dequeue_and_dispatch/1","title":"Exq.Manager.Server.dequeue_and_dispatch/1","type":"function"},{"doc":"Dispatch job to worker if it is not empty Also update worker count for dispatched job","ref":"Exq.Manager.Server.html#dispatch_job/2","title":"Exq.Manager.Server.dispatch_job/2","type":"function"},{"doc":"","ref":"Exq.Manager.Server.html#dispatch_job/3","title":"Exq.Manager.Server.dispatch_job/3","type":"function"},{"doc":"Cleanup host stats on boot","ref":"Exq.Manager.Server.html#handle_cast/2","title":"Exq.Manager.Server.handle_cast/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Manager.Server.html#init/1","title":"Exq.Manager.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Manager.Server.html#job_terminated/3","title":"Exq.Manager.Server.job_terminated/3","type":"function"},{"doc":"","ref":"Exq.Manager.Server.html#server_name/1","title":"Exq.Manager.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.Manager.Server.html#start_link/1","title":"Exq.Manager.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Manager.Server.State.html","title":"Exq.Manager.Server.State","type":"module"},{"doc":"","ref":"Exq.Middleware.Behaviour.html","title":"Exq.Middleware.Behaviour","type":"behaviour"},{"doc":"","ref":"Exq.Middleware.Behaviour.html#c:after_failed_work/1","title":"Exq.Middleware.Behaviour.after_failed_work/1","type":"callback"},{"doc":"","ref":"Exq.Middleware.Behaviour.html#c:after_processed_work/1","title":"Exq.Middleware.Behaviour.after_processed_work/1","type":"callback"},{"doc":"","ref":"Exq.Middleware.Behaviour.html#c:before_work/1","title":"Exq.Middleware.Behaviour.before_work/1","type":"callback"},{"doc":"","ref":"Exq.Middleware.Job.html","title":"Exq.Middleware.Job","type":"module"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_failed_work/1.","ref":"Exq.Middleware.Job.html#after_failed_work/1","title":"Exq.Middleware.Job.after_failed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_processed_work/1.","ref":"Exq.Middleware.Job.html#after_processed_work/1","title":"Exq.Middleware.Job.after_processed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.before_work/1.","ref":"Exq.Middleware.Job.html#before_work/1","title":"Exq.Middleware.Job.before_work/1","type":"function"},{"doc":"","ref":"Exq.Middleware.Job.html#remove_job_from_backup/1","title":"Exq.Middleware.Job.remove_job_from_backup/1","type":"function"},{"doc":"","ref":"Exq.Middleware.Logger.html","title":"Exq.Middleware.Logger","type":"module"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_failed_work/1.","ref":"Exq.Middleware.Logger.html#after_failed_work/1","title":"Exq.Middleware.Logger.after_failed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_processed_work/1.","ref":"Exq.Middleware.Logger.html#after_processed_work/1","title":"Exq.Middleware.Logger.after_processed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.before_work/1.","ref":"Exq.Middleware.Logger.html#before_work/1","title":"Exq.Middleware.Logger.before_work/1","type":"function"},{"doc":"","ref":"Exq.Middleware.Manager.html","title":"Exq.Middleware.Manager","type":"module"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_failed_work/1.","ref":"Exq.Middleware.Manager.html#after_failed_work/1","title":"Exq.Middleware.Manager.after_failed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_processed_work/1.","ref":"Exq.Middleware.Manager.html#after_processed_work/1","title":"Exq.Middleware.Manager.after_processed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.before_work/1.","ref":"Exq.Middleware.Manager.html#before_work/1","title":"Exq.Middleware.Manager.before_work/1","type":"function"},{"doc":"Pipeline is a structure that is used as an argument in functions of module with Exq.Middleware.Behaviour behaviour.This structure must be returned by particular function to be used in the next middleware based on defined middleware chain.Pipeline contains the following options:assigns - map that contains shared data across the whole job lifecycleworker_pid - process id of Exq.Worker.Serverevent - name of current middleware function, possible values are: before_work, after_processed_work and after_failed_workhalted - flag indicating whether pipeline was halted, defaults to falseterminated - flag indicating whether worker and pipeline were halted, If the flag was set to true, the job will not be dispatched and all after_*_work/1 will be skipped. For each specific middleware:Exq.Middleware.Job: Will NOT remove the backup from job queueExq.Middleware.Logger: Will NOT record job as done or failed with timestampExq.Middleware.Manager: Will NOT update worker counterExq.Middleware.Stats: Will NOT remove job from processes queue","ref":"Exq.Middleware.Pipeline.html","title":"Exq.Middleware.Pipeline","type":"module"},{"doc":"Puts the key with value equal to value into assigns map","ref":"Exq.Middleware.Pipeline.html#assign/3","title":"Exq.Middleware.Pipeline.assign/3","type":"function"},{"doc":"Puts a state of Exq.Worker.Server into assigns map","ref":"Exq.Middleware.Pipeline.html#assign_worker_state/2","title":"Exq.Middleware.Pipeline.assign_worker_state/2","type":"function"},{"doc":"Implements middleware chain: sequential call of function with pipeline.event name inside module module","ref":"Exq.Middleware.Pipeline.html#chain/2","title":"Exq.Middleware.Pipeline.chain/2","type":"function"},{"doc":"Sets halted to true","ref":"Exq.Middleware.Pipeline.html#halt/1","title":"Exq.Middleware.Pipeline.halt/1","type":"function"},{"doc":"\b\bSets terminated to true","ref":"Exq.Middleware.Pipeline.html#terminate/1","title":"Exq.Middleware.Pipeline.terminate/1","type":"function"},{"doc":"Middleware Server is responsible for storing middleware chain that is evaluated when performing particular job.Middleware chain defaults to Stats, Job and Manager middlewares.To push new middleware you must create module with common interface. Interface is similar to Plug implementation. It has three functions, every function receives Exq.Middlewares.Pipeline structure and every function must return the same structure, modified or not.Basically, before_work/1 function may update worker state, while after_processed_work/1 and after_failed_work/1 are for cleanup and notification stuff.For example, here is a valid middleware module:defmodule MyMiddleware do @behaiour Exq.Middleware.Behaviour def before_work(pipeline) do # some functionality goes here... pipeline end def after_processed_work(pipeline) do # some functionality goes here... pipeline end def after_failed_work(pipeline) do # some functionality goes here... pipeline end endTo add this module to middleware chain:Exq.Middleware.Server.push(middleware_server_pid, MyMiddleware)","ref":"Exq.Middleware.Server.html","title":"Exq.Middleware.Server","type":"module"},{"doc":"Retrieves list of middleware modules.","ref":"Exq.Middleware.Server.html#all/1","title":"Exq.Middleware.Server.all/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Middleware.Server.html#child_spec/1","title":"Exq.Middleware.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Middleware.Server.html#init/1","title":"Exq.Middleware.Server.init/1","type":"function"},{"doc":"Adds specified middleware module into the end of middleware list.middleware should have Exq.Middleware.Behaviour behaviour.","ref":"Exq.Middleware.Server.html#push/2","title":"Exq.Middleware.Server.push/2","type":"function"},{"doc":"Returns middleware server name.","ref":"Exq.Middleware.Server.html#server_name/1","title":"Exq.Middleware.Server.server_name/1","type":"function"},{"doc":"Starts middleware server.","ref":"Exq.Middleware.Server.html#start_link/1","title":"Exq.Middleware.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Middleware.Stats.html","title":"Exq.Middleware.Stats","type":"module"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_failed_work/1.","ref":"Exq.Middleware.Stats.html#after_failed_work/1","title":"Exq.Middleware.Stats.after_failed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.after_processed_work/1.","ref":"Exq.Middleware.Stats.html#after_processed_work/1","title":"Exq.Middleware.Stats.after_processed_work/1","type":"function"},{"doc":"Callback implementation for Exq.Middleware.Behaviour.before_work/1.","ref":"Exq.Middleware.Stats.html#before_work/1","title":"Exq.Middleware.Stats.before_work/1","type":"function"},{"doc":"This middleware allows you to subscribe to the telemetry events and collect metrics about your jobs.Exq telemetry eventsThe middleware emit three events, same as what :telemetry.span/3 emits.[:exq, :job, :start] - Is invoked whenever a job starts. Measurements system_time (integer) - System time when the job started[:exq, :job, :stop] - Is invoked whenever a job completes successfully. Measurements duration (integer) - Duration of the job execution in native unit[:exq, :job, :exception] - Is invoked whenever a job fails. Measurements duration (integer) - Duration of the job execution in native unit Metadata In addition to the common metadata, exception event will have the following fields.kind (exit | error) - either exit or errorreason (term) - could be an Exception.t/0 or termstacktrace (list) - Stacktrace of the error. Will be empty if the kind is exit. Metadata Each event has the following common metadata:enqueued_at (DateTime.t/0) - datetime the job was enqueuedqueue (String.t/0) - the name of the queue the job was executed inclass (String.t/0) - the job's classjid (String.t/0) - the job's jidretry_count (integer) - number of times this job has failed so farExamplesdefmodule MyApp.Application do def start(_type, _args) do children = [ # ..... {Telemetry.Metrics.ConsoleReporter, metrics: metrics()} ] opts = [strategy: :one_for_one, name: MyApp.Supervisor] Supervisor.start_link(children, opts) end defp metrics do [ counter(&quot;exq.job.stop.duration&quot;), counter(&quot;exq.job.exception.duration&quot;), distribution(&quot;exq.job.stop.duration&quot;, buckets: [0.1, 0.2, 0.3, 0.5, 0.75, 1, 2, 3, 5, 10], unit: {:native, :millisecond} ), distribution(&quot;exq.job.exception.duration&quot;, buckets: [0.1, 0.2, 0.3, 0.5, 0.75, 1, 2, 3, 5, 10], unit: {:native, :millisecond} ), summary(&quot;exq.job.stop.duration&quot;, unit: {:native, :millisecond}), summary(&quot;exq.job.exception.duration&quot;, unit: {:native, :millisecond}) ] end end","ref":"Exq.Middleware.Telemetry.html","title":"Exq.Middleware.Telemetry","type":"module"},{"doc":"","ref":"Exq.Mock.html","title":"Exq.Mock","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Mock.html#child_spec/1","title":"Exq.Mock.child_spec/1","type":"function"},{"doc":"List of enqueued jobs.This only works if the mode is set to :fake","ref":"Exq.Mock.html#jobs/0","title":"Exq.Mock.jobs/0","type":"function"},{"doc":"Set the mode for current test:redis - jobs get enqueued and processed via redis.:fake - jobs get enqueued in a local queue:inline - jobs get executed in the same process","ref":"Exq.Mock.html#set_mode/1","title":"Exq.Mock.set_mode/1","type":"function"},{"doc":"Start Mock servermode - The default mode that's used for all tests. See set_mode/1 for details.","ref":"Exq.Mock.html#start_link/1","title":"Exq.Mock.start_link/1","type":"function"},{"doc":"","ref":"Exq.Node.Server.html","title":"Exq.Node.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Node.Server.html#child_spec/1","title":"Exq.Node.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Node.Server.html#init/1","title":"Exq.Node.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Node.Server.html#start_link/1","title":"Exq.Node.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Node.Server.State.html","title":"Exq.Node.Server.State","type":"module"},{"doc":"","ref":"Exq.NodeIdentifier.Behaviour.html","title":"Exq.NodeIdentifier.Behaviour","type":"behaviour"},{"doc":"","ref":"Exq.NodeIdentifier.Behaviour.html#c:node_id/0","title":"Exq.NodeIdentifier.Behaviour.node_id/0","type":"callback"},{"doc":"","ref":"Exq.NodeIdentifier.HostnameIdentifier.html","title":"Exq.NodeIdentifier.HostnameIdentifier","type":"module"},{"doc":"Callback implementation for Exq.NodeIdentifier.Behaviour.node_id/0.","ref":"Exq.NodeIdentifier.HostnameIdentifier.html#node_id/0","title":"Exq.NodeIdentifier.HostnameIdentifier.node_id/0","type":"function"},{"doc":"The Connection module encapsulates interaction with a live Redis connection or pool.","ref":"Exq.Redis.Connection.html","title":"Exq.Redis.Connection","type":"module"},{"doc":"","ref":"Exq.Redis.Connection.html#decr!/2","title":"Exq.Redis.Connection.decr!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#del!/2","title":"Exq.Redis.Connection.del!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#expire!/3","title":"Exq.Redis.Connection.expire!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#flushdb!/1","title":"Exq.Redis.Connection.flushdb!/1","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#get!/2","title":"Exq.Redis.Connection.get!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#incr!/2","title":"Exq.Redis.Connection.incr!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#keys!/2","title":"Exq.Redis.Connection.keys!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#llen!/2","title":"Exq.Redis.Connection.llen!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#lpop/2","title":"Exq.Redis.Connection.lpop/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#lpush!/3","title":"Exq.Redis.Connection.lpush!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#lrange!/4","title":"Exq.Redis.Connection.lrange!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#lrem!/5","title":"Exq.Redis.Connection.lrem!/5","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#q/3","title":"Exq.Redis.Connection.q/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#qp/3","title":"Exq.Redis.Connection.qp/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#qp!/3","title":"Exq.Redis.Connection.qp!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#rpush!/3","title":"Exq.Redis.Connection.rpush!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#sadd!/3","title":"Exq.Redis.Connection.sadd!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#scan!/4","title":"Exq.Redis.Connection.scan!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#scard!/2","title":"Exq.Redis.Connection.scard!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#set!/3","title":"Exq.Redis.Connection.set!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#sismember!/3","title":"Exq.Redis.Connection.sismember!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#smembers!/2","title":"Exq.Redis.Connection.smembers!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#srem!/3","title":"Exq.Redis.Connection.srem!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zadd/5","title":"Exq.Redis.Connection.zadd/5","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zadd!/4","title":"Exq.Redis.Connection.zadd!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zcard!/2","title":"Exq.Redis.Connection.zcard!/2","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zcount!/4","title":"Exq.Redis.Connection.zcount!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrange!/4","title":"Exq.Redis.Connection.zrange!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscore/4","title":"Exq.Redis.Connection.zrangebyscore/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscore!/4","title":"Exq.Redis.Connection.zrangebyscore!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscorewithlimit!/6","title":"Exq.Redis.Connection.zrangebyscorewithlimit!/6","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscorewithscore/4","title":"Exq.Redis.Connection.zrangebyscorewithscore/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscorewithscore!/4","title":"Exq.Redis.Connection.zrangebyscorewithscore!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrangebyscorewithscoreandlimit!/6","title":"Exq.Redis.Connection.zrangebyscorewithscoreandlimit!/6","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrem/3","title":"Exq.Redis.Connection.zrem/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrem!/3","title":"Exq.Redis.Connection.zrem!/3","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrevrangebyscorewithlimit!/6","title":"Exq.Redis.Connection.zrevrangebyscorewithlimit!/6","type":"function"},{"doc":"","ref":"Exq.Redis.Connection.html#zrevrangebyscorewithscoreandlimit!/6","title":"Exq.Redis.Connection.zrevrangebyscorewithscoreandlimit!/6","type":"function"},{"doc":"","ref":"Exq.Redis.Heartbeat.html","title":"Exq.Redis.Heartbeat","type":"module"},{"doc":"","ref":"Exq.Redis.Heartbeat.html#dead_nodes/4","title":"Exq.Redis.Heartbeat.dead_nodes/4","type":"function"},{"doc":"","ref":"Exq.Redis.Heartbeat.html#re_enqueue_backup/5","title":"Exq.Redis.Heartbeat.re_enqueue_backup/5","type":"function"},{"doc":"","ref":"Exq.Redis.Heartbeat.html#register/3","title":"Exq.Redis.Heartbeat.register/3","type":"function"},{"doc":"","ref":"Exq.Redis.Heartbeat.html#unregister/3","title":"Exq.Redis.Heartbeat.unregister/3","type":"function"},{"doc":"The JobQueue module is the main abstraction of a job queue on top of Redis.It provides functionality for:Storing jobs in RedisFetching the next job(s) to be executed (and storing a backup of these).Scheduling future jobs in RedisFetching scheduling jobs and moving them to current job listRetrying or failing a jobRe-hydrating jobs from a backup queue","ref":"Exq.Redis.JobQueue.html","title":"Exq.Redis.JobQueue","type":"module"},{"doc":"","ref":"Exq.Redis.JobQueue.html#backup_queue_key/3","title":"Exq.Redis.JobQueue.backup_queue_key/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#delete_queue/3","title":"Exq.Redis.JobQueue.delete_queue/3","type":"function"},{"doc":"Dequeue jobs for available queues","ref":"Exq.Redis.JobQueue.html#dequeue/4","title":"Exq.Redis.JobQueue.dequeue/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#dequeue_failed_jobs/3","title":"Exq.Redis.JobQueue.dequeue_failed_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#dequeue_retry_jobs/3","title":"Exq.Redis.JobQueue.dequeue_retry_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#dequeue_scheduled_jobs/3","title":"Exq.Redis.JobQueue.dequeue_scheduled_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue/3","title":"Exq.Redis.JobQueue.enqueue/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue/4","title":"Exq.Redis.JobQueue.enqueue/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue/6","title":"Exq.Redis.JobQueue.enqueue/6","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue_at/7","title":"Exq.Redis.JobQueue.enqueue_at/7","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue_in/7","title":"Exq.Redis.JobQueue.enqueue_in/7","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#enqueue_job_at/6","title":"Exq.Redis.JobQueue.enqueue_job_at/6","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#fail_job/4","title":"Exq.Redis.JobQueue.fail_job/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#failed/3","title":"Exq.Redis.JobQueue.failed/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#failed_queue_key/1","title":"Exq.Redis.JobQueue.failed_queue_key/1","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#failed_size/2","title":"Exq.Redis.JobQueue.failed_size/2","type":"function"},{"doc":"Find a current job by job id (but do not pop it)","ref":"Exq.Redis.JobQueue.html#find_job/4","title":"Exq.Redis.JobQueue.find_job/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#find_job/5","title":"Exq.Redis.JobQueue.find_job/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#full_key/2","title":"Exq.Redis.JobQueue.full_key/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#jobs/2","title":"Exq.Redis.JobQueue.jobs/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#jobs/4","title":"Exq.Redis.JobQueue.jobs/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#list_queues/2","title":"Exq.Redis.JobQueue.list_queues/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#queue_key/2","title":"Exq.Redis.JobQueue.queue_key/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#queue_size/2","title":"Exq.Redis.JobQueue.queue_size/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#queue_size/3","title":"Exq.Redis.JobQueue.queue_size/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#re_enqueue_backup/4","title":"Exq.Redis.JobQueue.re_enqueue_backup/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_enqueued_jobs/4","title":"Exq.Redis.JobQueue.remove_enqueued_jobs/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_failed_jobs/3","title":"Exq.Redis.JobQueue.remove_failed_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_job/4","title":"Exq.Redis.JobQueue.remove_job/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_job_from_backup/5","title":"Exq.Redis.JobQueue.remove_job_from_backup/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_retry/3","title":"Exq.Redis.JobQueue.remove_retry/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_retry_jobs/3","title":"Exq.Redis.JobQueue.remove_retry_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_scheduled/3","title":"Exq.Redis.JobQueue.remove_scheduled/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#remove_scheduled_jobs/3","title":"Exq.Redis.JobQueue.remove_scheduled_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#retry_job/3","title":"Exq.Redis.JobQueue.retry_job/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#retry_job/5","title":"Exq.Redis.JobQueue.retry_job/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#retry_or_fail_job/4","title":"Exq.Redis.JobQueue.retry_or_fail_job/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#retry_queue_key/1","title":"Exq.Redis.JobQueue.retry_queue_key/1","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#retry_size/2","title":"Exq.Redis.JobQueue.retry_size/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#schedule_queues/1","title":"Exq.Redis.JobQueue.schedule_queues/1","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduled_jobs/4","title":"Exq.Redis.JobQueue.scheduled_jobs/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduled_jobs_with_scores/4","title":"Exq.Redis.JobQueue.scheduled_jobs_with_scores/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduled_queue_key/1","title":"Exq.Redis.JobQueue.scheduled_queue_key/1","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduled_size/2","title":"Exq.Redis.JobQueue.scheduled_size/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduler_dequeue/2","title":"Exq.Redis.JobQueue.scheduler_dequeue/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#scheduler_dequeue/3","title":"Exq.Redis.JobQueue.scheduler_dequeue/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#search_jobs/2","title":"Exq.Redis.JobQueue.search_jobs/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#search_jobs/3","title":"Exq.Redis.JobQueue.search_jobs/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#to_job_serialized/4","title":"Exq.Redis.JobQueue.to_job_serialized/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobQueue.html#to_job_serialized/5","title":"Exq.Redis.JobQueue.to_job_serialized/5","type":"function"},{"doc":"The JobStat module encapsulates storing system-wide stats on top of Redis It aims to be compatible with the Sidekiq stats format.","ref":"Exq.Redis.JobStat.html","title":"Exq.Redis.JobStat","type":"module"},{"doc":"","ref":"Exq.Redis.JobStat.html#add_process/4","title":"Exq.Redis.JobStat.add_process/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#add_process_commands/3","title":"Exq.Redis.JobStat.add_process_commands/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#busy/2","title":"Exq.Redis.JobStat.busy/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#cleanup_processes/3","title":"Exq.Redis.JobStat.cleanup_processes/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#clear_failed/2","title":"Exq.Redis.JobStat.clear_failed/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#clear_processes/2","title":"Exq.Redis.JobStat.clear_processes/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#decode_integer/1","title":"Exq.Redis.JobStat.decode_integer/1","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#find_failed/3","title":"Exq.Redis.JobStat.find_failed/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#find_failed/5","title":"Exq.Redis.JobStat.find_failed/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#find_retry/5","title":"Exq.Redis.JobStat.find_retry/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#find_scheduled/5","title":"Exq.Redis.JobStat.find_scheduled/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#get_count/3","title":"Exq.Redis.JobStat.get_count/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#get_counts/3","title":"Exq.Redis.JobStat.get_counts/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#node_ids/2","title":"Exq.Redis.JobStat.node_ids/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#node_ping/3","title":"Exq.Redis.JobStat.node_ping/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#nodes/2","title":"Exq.Redis.JobStat.nodes/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#processes/2","title":"Exq.Redis.JobStat.processes/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#prune_dead_nodes/2","title":"Exq.Redis.JobStat.prune_dead_nodes/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#realtime_stats/2","title":"Exq.Redis.JobStat.realtime_stats/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#record_failure/5","title":"Exq.Redis.JobStat.record_failure/5","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#record_failure_commands/4","title":"Exq.Redis.JobStat.record_failure_commands/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#record_processed/4","title":"Exq.Redis.JobStat.record_processed/4","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#record_processed_commands/3","title":"Exq.Redis.JobStat.record_processed_commands/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#remove_failed/3","title":"Exq.Redis.JobStat.remove_failed/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#remove_process/3","title":"Exq.Redis.JobStat.remove_process/3","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#remove_process_commands/2","title":"Exq.Redis.JobStat.remove_process_commands/2","type":"function"},{"doc":"","ref":"Exq.Redis.JobStat.html#remove_queue/3","title":"Exq.Redis.JobStat.remove_queue/3","type":"function"},{"doc":"","ref":"Exq.Redis.Script.html","title":"Exq.Redis.Script","type":"module"},{"doc":"","ref":"Exq.Redis.Script.html#eval!/4","title":"Exq.Redis.Script.eval!/4","type":"function"},{"doc":"","ref":"Exq.Redis.Script.Prepare.html","title":"Exq.Redis.Script.Prepare","type":"module"},{"doc":"","ref":"Exq.Redis.Script.Prepare.html#script/1","title":"Exq.Redis.Script.Prepare.script/1","type":"function"},{"doc":"The Scheduler is responsible for monitoring the schedule and retry queues. These queues use a Redis sorted set (term?) to schedule and pick off due jobs. Once a job is at or past it's execution date, the Scheduler moves the job into the live execution queue.Runs on a timed loop according to scheduler_poll_timeout.Initialization::name - Name of target registered process:namespace - Redis namespace to store all data under. Defaults to &quot;exq&quot;.:queues - Array of currently active queues (TODO: Remove, I suspect it's not needed).:redis - pid of Redis process.:scheduler_poll_timeout - How often to poll Redis for scheduled / retry jobs.","ref":"Exq.Scheduler.Server.html","title":"Exq.Scheduler.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Scheduler.Server.html#child_spec/1","title":"Exq.Scheduler.Server.child_spec/1","type":"function"},{"doc":"Dequeue any active jobs in the scheduled and retry queues, and enqueue them to live queue.","ref":"Exq.Scheduler.Server.html#dequeue/1","title":"Exq.Scheduler.Server.dequeue/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Scheduler.Server.html#init/1","title":"Exq.Scheduler.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Scheduler.Server.html#server_name/1","title":"Exq.Scheduler.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.Scheduler.Server.html#start_link/1","title":"Exq.Scheduler.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Scheduler.Server.html#start_timeout/1","title":"Exq.Scheduler.Server.start_timeout/1","type":"function"},{"doc":"","ref":"Exq.Scheduler.Server.State.html","title":"Exq.Scheduler.Server.State","type":"module"},{"doc":"","ref":"Exq.Serializers.Behaviour.html","title":"Exq.Serializers.Behaviour","type":"behaviour"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:decode/1","title":"Exq.Serializers.Behaviour.decode/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:decode!/1","title":"Exq.Serializers.Behaviour.decode!/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:decode_job/1","title":"Exq.Serializers.Behaviour.decode_job/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:decode_process/1","title":"Exq.Serializers.Behaviour.decode_process/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:encode/1","title":"Exq.Serializers.Behaviour.encode/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:encode!/1","title":"Exq.Serializers.Behaviour.encode!/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:encode_job/1","title":"Exq.Serializers.Behaviour.encode_job/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.Behaviour.html#c:encode_process/1","title":"Exq.Serializers.Behaviour.encode_process/1","type":"callback"},{"doc":"","ref":"Exq.Serializers.JsonSerializer.html","title":"Exq.Serializers.JsonSerializer","type":"module"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.decode/1.","ref":"Exq.Serializers.JsonSerializer.html#decode/1","title":"Exq.Serializers.JsonSerializer.decode/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.decode!/1.","ref":"Exq.Serializers.JsonSerializer.html#decode!/1","title":"Exq.Serializers.JsonSerializer.decode!/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.decode_job/1.","ref":"Exq.Serializers.JsonSerializer.html#decode_job/1","title":"Exq.Serializers.JsonSerializer.decode_job/1","type":"function"},{"doc":"","ref":"Exq.Serializers.JsonSerializer.html#decode_node/1","title":"Exq.Serializers.JsonSerializer.decode_node/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.decode_process/1.","ref":"Exq.Serializers.JsonSerializer.html#decode_process/1","title":"Exq.Serializers.JsonSerializer.decode_process/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.encode/1.","ref":"Exq.Serializers.JsonSerializer.html#encode/1","title":"Exq.Serializers.JsonSerializer.encode/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.encode!/1.","ref":"Exq.Serializers.JsonSerializer.html#encode!/1","title":"Exq.Serializers.JsonSerializer.encode!/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.encode_job/1.","ref":"Exq.Serializers.JsonSerializer.html#encode_job/1","title":"Exq.Serializers.JsonSerializer.encode_job/1","type":"function"},{"doc":"","ref":"Exq.Serializers.JsonSerializer.html#encode_node/1","title":"Exq.Serializers.JsonSerializer.encode_node/1","type":"function"},{"doc":"Callback implementation for Exq.Serializers.Behaviour.encode_process/1.","ref":"Exq.Serializers.JsonSerializer.html#encode_process/1","title":"Exq.Serializers.JsonSerializer.encode_process/1","type":"function"},{"doc":"Stats process is responsible for recording all stats into Redis.The stats format is compatible with the Sidekiq stats format, so that The Sidekiq UI can be also used to view Exq status as well, and Exq can run side by side with Sidekiq without breaking any of it's UI.This includes job success/failure as well as in-progress jobs","ref":"Exq.Stats.Server.html","title":"Exq.Stats.Server","type":"module"},{"doc":"Add in progress worker process","ref":"Exq.Stats.Server.html#add_process/6","title":"Exq.Stats.Server.add_process/6","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Stats.Server.html#child_spec/1","title":"Exq.Stats.Server.child_spec/1","type":"function"},{"doc":"Cleanup stats on boot. This includes cleaning up busy workers.","ref":"Exq.Stats.Server.html#cleanup_host_stats/3","title":"Exq.Stats.Server.cleanup_host_stats/3","type":"function"},{"doc":"","ref":"Exq.Stats.Server.html#force_flush/1","title":"Exq.Stats.Server.force_flush/1","type":"function"},{"doc":"","ref":"Exq.Stats.Server.html#generate_instructions/1","title":"Exq.Stats.Server.generate_instructions/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Stats.Server.html#init/1","title":"Exq.Stats.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Stats.Server.html#process_queue/4","title":"Exq.Stats.Server.process_queue/4","type":"function"},{"doc":"Remove in progress worker process","ref":"Exq.Stats.Server.html#process_terminated/3","title":"Exq.Stats.Server.process_terminated/3","type":"function"},{"doc":"Record job as failed","ref":"Exq.Stats.Server.html#record_failure/4","title":"Exq.Stats.Server.record_failure/4","type":"function"},{"doc":"Record job as successfully processes","ref":"Exq.Stats.Server.html#record_processed/3","title":"Exq.Stats.Server.record_processed/3","type":"function"},{"doc":"","ref":"Exq.Stats.Server.html#server_name/1","title":"Exq.Stats.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.Stats.Server.html#start_link/1","title":"Exq.Stats.Server.start_link/1","type":"function"},{"doc":"","ref":"Exq.Stats.Server.State.html","title":"Exq.Stats.Server.State","type":"module"},{"doc":"","ref":"Exq.Support.Binary.html","title":"Exq.Support.Binary","type":"module"},{"doc":"","ref":"Exq.Support.Binary.html#take_prefix/2","title":"Exq.Support.Binary.take_prefix/2","type":"function"},{"doc":"","ref":"Exq.Support.Config.html","title":"Exq.Support.Config","type":"module"},{"doc":"","ref":"Exq.Support.Config.html#backoff/0","title":"Exq.Support.Config.backoff/0","type":"function"},{"doc":"","ref":"Exq.Support.Config.html#get/1","title":"Exq.Support.Config.get/1","type":"function"},{"doc":"","ref":"Exq.Support.Config.html#get/2","title":"Exq.Support.Config.get/2","type":"function"},{"doc":"","ref":"Exq.Support.Config.html#node_identifier/0","title":"Exq.Support.Config.node_identifier/0","type":"function"},{"doc":"","ref":"Exq.Support.Config.html#serializer/0","title":"Exq.Support.Config.serializer/0","type":"function"},{"doc":"Serializable Job format used by Exq.","ref":"Exq.Support.Job.html","title":"Exq.Support.Job","type":"module"},{"doc":"","ref":"Exq.Support.Job.html#decode/1","title":"Exq.Support.Job.decode/1","type":"function"},{"doc":"","ref":"Exq.Support.Job.html#encode/1","title":"Exq.Support.Job.encode/1","type":"function"},{"doc":"This module defines several modes in which Exq can be used.These modes are:default - starts the default processesenqueuer - starts processes which are responsible for job enqueueingapi - starts processes which are responsible for API usage","ref":"Exq.Support.Mode.html","title":"Exq.Support.Mode","type":"module"},{"doc":"Returns child list for the main Exq supervisor.","ref":"Exq.Support.Mode.html#children/1","title":"Exq.Support.Mode.children/1","type":"function"},{"doc":"","ref":"Exq.Support.Mode.html#children/2","title":"Exq.Support.Mode.children/2","type":"function"},{"doc":"Struct for node.","ref":"Exq.Support.Node.html","title":"Exq.Support.Node","type":"module"},{"doc":"Decode JSON into node.","ref":"Exq.Support.Node.html#decode/1","title":"Exq.Support.Node.decode/1","type":"function"},{"doc":"Serialize node to JSON.","ref":"Exq.Support.Node.html#encode/1","title":"Exq.Support.Node.encode/1","type":"function"},{"doc":"Exq supported options.","ref":"Exq.Support.Opts.html","title":"Exq.Support.Opts","type":"module"},{"doc":"","ref":"Exq.Support.Opts.html#cast_concurrency/1","title":"Exq.Support.Opts.cast_concurrency/1","type":"function"},{"doc":"","ref":"Exq.Support.Opts.html#redis_client_name/1","title":"Exq.Support.Opts.redis_client_name/1","type":"function"},{"doc":"","ref":"Exq.Support.Opts.html#redis_inspect_opts/1","title":"Exq.Support.Opts.redis_inspect_opts/1","type":"function"},{"doc":"","ref":"Exq.Support.Opts.html#redis_opts/1","title":"Exq.Support.Opts.redis_opts/1","type":"function"},{"doc":"Returns {redis_module, redis_args, gen_server_opts}.","ref":"Exq.Support.Opts.html#redis_worker_opts/1","title":"Exq.Support.Opts.redis_worker_opts/1","type":"function"},{"doc":"Returns top supervisor's name default is Exq.Sup.","ref":"Exq.Support.Opts.html#top_supervisor/1","title":"Exq.Support.Opts.top_supervisor/1","type":"function"},{"doc":"Struct for in progress worker.","ref":"Exq.Support.Process.html","title":"Exq.Support.Process","type":"module"},{"doc":"Decode JSON into process.","ref":"Exq.Support.Process.html#decode/1","title":"Exq.Support.Process.decode/1","type":"function"},{"doc":"Serialize process to JSON.","ref":"Exq.Support.Process.html#encode/1","title":"Exq.Support.Process.encode/1","type":"function"},{"doc":"Helper functions for random number.","ref":"Exq.Support.Randomize.html","title":"Exq.Support.Randomize","type":"module"},{"doc":"","ref":"Exq.Support.Randomize.html#random/1","title":"Exq.Support.Randomize.random/1","type":"function"},{"doc":"","ref":"Exq.Support.Redis.html","title":"Exq.Support.Redis","type":"module"},{"doc":"Rescue GenServer timeout.","ref":"Exq.Support.Redis.html#rescue_timeout/2","title":"Exq.Support.Redis.rescue_timeout/2","type":"function"},{"doc":"","ref":"Exq.Support.Redis.html#with_retry_on_connection_error/2","title":"Exq.Support.Redis.with_retry_on_connection_error/2","type":"function"},{"doc":"Helper functions for data and time.","ref":"Exq.Support.Time.html","title":"Exq.Support.Time","type":"module"},{"doc":"","ref":"Exq.Support.Time.html#format_current_date/1","title":"Exq.Support.Time.format_current_date/1","type":"function"},{"doc":"","ref":"Exq.Support.Time.html#offset_from_now/1","title":"Exq.Support.Time.offset_from_now/1","type":"function"},{"doc":"","ref":"Exq.Support.Time.html#time_to_score/1","title":"Exq.Support.Time.time_to_score/1","type":"function"},{"doc":"","ref":"Exq.Support.Time.html#unix_seconds/1","title":"Exq.Support.Time.unix_seconds/1","type":"function"},{"doc":"Provides storage functionality for job metadata.The metadata is associated with the worker pid and automatically discarded when the worker process exits.","ref":"Exq.Worker.Metadata.html","title":"Exq.Worker.Metadata","type":"module"},{"doc":"","ref":"Exq.Worker.Metadata.html#associate/3","title":"Exq.Worker.Metadata.associate/3","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Worker.Metadata.html#child_spec/1","title":"Exq.Worker.Metadata.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Worker.Metadata.html#init/1","title":"Exq.Worker.Metadata.init/1","type":"function"},{"doc":"","ref":"Exq.Worker.Metadata.html#lookup/2","title":"Exq.Worker.Metadata.lookup/2","type":"function"},{"doc":"","ref":"Exq.Worker.Metadata.html#server_name/1","title":"Exq.Worker.Metadata.server_name/1","type":"function"},{"doc":"","ref":"Exq.Worker.Metadata.html#start_link/1","title":"Exq.Worker.Metadata.start_link/1","type":"function"},{"doc":"Worker process is responsible for the parsing and execution of a Job.It then broadcasts results to Stats / Manager.Currently uses the terminate callback to track job success/failure.Initialization:job_serialized - Full JSON payload of the Job.manager - Manager process pid.queue - The queue the job came from.stats - Stats process pid.namespace - Redis namespacehost - Host nameExpects :work message after initialization to kickoff work.","ref":"Exq.Worker.Server.html","title":"Exq.Worker.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Worker.Server.html#child_spec/1","title":"Exq.Worker.Server.child_spec/1","type":"function"},{"doc":"","ref":"Exq.Worker.Server.html#dispatch_work/3","title":"Exq.Worker.Server.dispatch_work/3","type":"function"},{"doc":"Worker done with normal termination message.","ref":"Exq.Worker.Server.html#handle_cast/2","title":"Exq.Worker.Server.handle_cast/2","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.Worker.Server.html#init/1","title":"Exq.Worker.Server.init/1","type":"function"},{"doc":"","ref":"Exq.Worker.Server.html#start_link/9","title":"Exq.Worker.Server.start_link/9","type":"function"},{"doc":"Kickoff work associated with worker.","ref":"Exq.Worker.Server.html#work/1","title":"Exq.Worker.Server.work/1","type":"function"},{"doc":"","ref":"Exq.Worker.Server.State.html","title":"Exq.Worker.Server.State","type":"module"},{"doc":"Supervisor for Exq Worker.","ref":"Exq.Worker.Supervisor.html","title":"Exq.Worker.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.Worker.Supervisor.html#child_spec/1","title":"Exq.Worker.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for DynamicSupervisor.init/1.","ref":"Exq.Worker.Supervisor.html#init/1","title":"Exq.Worker.Supervisor.init/1","type":"function"},{"doc":"","ref":"Exq.Worker.Supervisor.html#start_child/3","title":"Exq.Worker.Supervisor.start_child/3","type":"function"},{"doc":"","ref":"Exq.Worker.Supervisor.html#start_link/1","title":"Exq.Worker.Supervisor.start_link/1","type":"function"},{"doc":"","ref":"Exq.Worker.Supervisor.html#supervisor_name/1","title":"Exq.Worker.Supervisor.supervisor_name/1","type":"function"},{"doc":"","ref":"Exq.Worker.Supervisor.html#workers/1","title":"Exq.Worker.Supervisor.workers/1","type":"function"},{"doc":"","ref":"Exq.Worker.Supervisor.html#workers_count/1","title":"Exq.Worker.Supervisor.workers_count/1","type":"function"},{"doc":"The WorkerDrainer server is responsible for gracefully draining workers when the application is shutting down.When shutdown starts it instructs the Manager to stop accepting new jobs and then waits for all currently in progress jobs to complete.If the jobs do not complete within an allowed timeout the WorkerDrainer will shut down, allowing the rest of the supervision tree (including the remaining workers) to then shut down.The length of the grace period can be configured with the shutdown_timeout option, which defaults to 5000 ms.","ref":"Exq.WorkerDrainer.Server.html","title":"Exq.WorkerDrainer.Server","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Exq.WorkerDrainer.Server.html#child_spec/1","title":"Exq.WorkerDrainer.Server.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Exq.WorkerDrainer.Server.html#init/1","title":"Exq.WorkerDrainer.Server.init/1","type":"function"},{"doc":"","ref":"Exq.WorkerDrainer.Server.html#server_name/1","title":"Exq.WorkerDrainer.Server.server_name/1","type":"function"},{"doc":"","ref":"Exq.WorkerDrainer.Server.html#start_link/1","title":"Exq.WorkerDrainer.Server.start_link/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Exq.Run.html","title":"Mix.Tasks.Exq.Run","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Exq.Run.html#run/1","title":"Mix.Tasks.Exq.Run.run/1","type":"function"},{"doc":"ChangelogAll notable changes to this project will be documented in this file.The format is based on Keep a Changelog.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [Unreleased]","type":"extras"},{"doc":"NOTE: Please read PR #458 for upgrade instructions.AddedAdd retried_at field for Sidekiq compatibility #450 by @ananthakumaranAdd apis to support exq_ui #452 by @ananthakumaranAdd documentation about mode: :enqueuer and Exq.Enqueuer.queue_in #456 by @dbernheiselAdd api to immediatly enqeueue jobs from retry/scheduled queue #461 by @ananthakumaranAdd api to re-enqueue dead job #462 by @ananthakumaranChangedAdd Sidekiq 5 compatibility #458 by @ananthakumaranUse latest Phoenix child spec style #459 by @vovayartsevReplace deprecated supervisor calls #453 by @vkuznetsovFixedHandle timeouts on middleware pipeline #444 by @ananthakumaranUse the correct scheduled time for enqueued_at field for mock #449 by @ananthakumaran","ref":"changelog.html#0-16-0-2021-12-12","title":"Changelog - [0.16.0] - 2021-12-12","type":"extras"},{"doc":"AddedAdd dequeue behavior for ability to implement things like concurrency control #421 by @ananthakumaranApi Module Documentation #440 by @kevin-j-mChangedUse Lua script to schedule job for better performance and memory leak fix #427 by @ananthakumaranLogging fixes #429 by @rraubRelax poison dependency #431 by @ananthakumaranUse github actions instead of Travis #433 by @ananthakumaranUse the same same module conversion logic in mock as well #434 by @ananthakumaranuse Task instead of spawn_link for starting workers #436 by @mitchellhenkeFixedre-enqueue unfinished jobs to the begining of queue on restart #424 by @ananthakumaranFix for sentinel 0.11.0+ #428 by @ananthakumaranFixes for generated HTML docs by #442 @kianmeng","ref":"changelog.html#0-15-0-2021-07-19","title":"Changelog - [0.15.0] - 2021-07-19","type":"extras"},{"doc":"AddedNode heartbeat functionality for dynamic environments #392 by @ananthakumaran (disabled by default).Exq telemetry events #414 by @hezAllow custom job IDs #417 by @bradedigerChangedDon't log Redis disconnects #420 by @isaacsandersFixedexq.run mix task starts dependent apps as well #408 by @ananthakumaranCast queue level concurrency #401 by @ananthakumaranFix documentation typo #423 by @LionsHeadFix conflicting unit in docs #419 by @JamesFerguson","ref":"changelog.html#0-14-0-2020-08-08","title":"Changelog - [0.14.0] - 2020-08-08","type":"extras"},{"doc":"AddedQueue adapter for mock testing @ananthakumaran and @samidarko","ref":"changelog.html#0-13-5-2020-01-01","title":"Changelog - [0.13.5] - 2020-01-01","type":"extras"},{"doc":"FixedRemove unnecessary serialization of enqueue calls #390 by @ananthakumaran and @sb8244Fix warnings by @hkrutzer #394Start all the apps during test by @ananthakumaran #391Replace KEYS with a cursored call to SCAN for realtime stats by @neslinesli93 #384","ref":"changelog.html#0-13-4-2019-11-03","title":"Changelog - [0.13.4] - 2019-11-03","type":"extras"},{"doc":"AddedHandle AWS Elasticache Redis DNS failover. This ensures persistent connections are shutdown, forcing a reconnect in scenarios where a Redis node in a HA cluster is switched to READONLY mode by @deepfryed.","ref":"changelog.html#0-13-3-2019-06-16","title":"Changelog - [0.13.3] - 2019-06-16","type":"extras"},{"doc":"FixedFix json_library issue #369 needing addition to config file. Add default value.","ref":"changelog.html#0-13-2-2019-03-15","title":"Changelog - [0.13.2] - 2019-03-15","type":"extras"},{"doc":"AddedSupport for configurable JSON parser, with Jason as default by @chulkilee.FixedRemove redundant time output for worker log by @akira.Fix deprecated time warning by @gvl.","ref":"changelog.html#0-13-1-2019-02-24","title":"Changelog - [0.13.1] - 2019-02-24","type":"extras"},{"doc":"RemovedDue to library dependencies, support for Elixir 1.3, Elixir 1.4 and OTP 18.0, OTP 19.0 has been removed.Redix version older than 0.8.1 is no longer supported.Config options reconnect_on_sleep and redis_timeout are now removed.AddedSupport for Redix &gt;= 0.8.1 by @ryansch and @ananthakumaran.Configuration for Mix Format by @chulkilee.Use :microsecond vs :microseconds by @KalvinHom.ChangedRedis options are now passed in via redis_options by @ryansch and @ananthakumaran.Removed redix_sentinel dependency, now supported by new Redix version by @ananthakumaran.","ref":"changelog.html#0-13-0-2019-01-21","title":"Changelog - [0.13.0] - 2019-01-21","type":"extras"},{"doc":"FixedDon't assume redis_opts is enumerable by @ryansch.AddedAdd {:system, VAR} format support for more config params by @LysanderGGAllow setting mode to both [:enqueuer, :api] by @buobChangedSpecify less than 0.8.0 on redix version in mix.exs by @buob","ref":"changelog.html#0-12-2-2018-10-14","title":"Changelog - [0.12.2] - 2018-10-14","type":"extras"},{"doc":"FixedCleanup packaging for elixir_uuid change.","ref":"changelog.html#0-12-1-2018-07-13","title":"Changelog - [0.12.1] - 2018-07-13","type":"extras"},{"doc":"FixedChange uuid to elixir_uuid which has been renamed. This will prevent future namespace clashes by @tzilist.","ref":"changelog.html#0-12-0-2018-07-12","title":"Changelog - [0.12.0] - 2018-07-12","type":"extras"},{"doc":"AddedTrim dead jobs queue after certain size by @ananthakumaran.Add an api to list all subscriptions (active queues) by @robobakery.Have top supervisor wait for worker drainer to gracefully terminate @frahugo.","ref":"changelog.html#0-11-0-2018-05-12","title":"Changelog - [0.11.0] - 2018-05-12","type":"extras"},{"doc":"FixedFix retry for Sidekiq job format using retry =&gt; true by @deepfryed.","ref":"changelog.html#0-10-1-2018-02-11","title":"Changelog - [0.10.1] - 2018-02-11","type":"extras"},{"doc":"FixedRemove Password logging by @akira.AddedRedis Sentinel support by @ananthakumaran.Make redis module name and start_link args configurable @ananthakumaran.","ref":"changelog.html#0-10-0-2018-02-11","title":"Changelog - [0.10.0] - 2018-02-11","type":"extras"},{"doc":"Exq Exq is a job processing library compatible with Resque / Sidekiq for the Elixir language.Exq uses Redis as a store for background processing jobs.Exq handles concurrency, job persistence, job retries, reliable queueing and tracking so you don't have to.Jobs are persistent so they would survive across node restarts.You can use multiple Erlang nodes to process from the same pool of jobs.Exq uses a format that is Resque/Sidekiq compatible.This means you can use it to integrate with existing Rails / Django projects that also use a background job that's Resque compatible - typically with little or no changes needed to your existing apps. However, you can also use Exq standalone.You can also use the Sidekiq UI to view job statuses, as Exq is compatible with the Sidekiq stats format.You can run both Exq and Toniq in the same app for different workers.Exq supports uncapped amount of jobs running, or also allows a max limit per queue.Exq supports job retries with exponential backoff.Exq supports configurable middleware for customization / plugins.Exq tracks several stats including failed busy, and processed jobs.Exq stores in progress jobs in a backup queue (using the Redis RPOPLPUSH command). This means that if the system or worker is restarted while a job is in progress, the job will be re_enqueued when the node is restarted and not lost.Exq provides an optional web UI that you can use to view several stats as well as rate of job processing.When shutting down Exq will attempt to let workers terminate gracefully, with a configurable timeout.There is no time limit to how long a job can run for.Do you need Exq?While you may reach for Sidekiq / Resque / Celery by default when writing apps in other languages, in Elixir there are some good options to consider that are already provided by the language and platform. So before adding Exq or any Redis backed queueing library to your application, make sure to get familiar with OTP and see if that is enough for your needs. Redis backed queueing libraries do add additional infrastructure complexity and also overhead due to serialization / marshalling, so make sure to evaluate whether it is an actual need or not.Some OTP related documentation to look at:GenServer: http://elixir-lang.org/getting-started/mix-otp/genserver.htmlTask: https://hexdocs.pm/elixir/Task.htmlGenStage: https://hexdocs.pm/gen_stage/GenStage.htmlSupervisor: http://elixir-lang.org/getting-started/mix-otp/supervisor-and-application.htmlOTP: http://erlang.org/doc/If you need a durable jobs, retries with exponential backoffs, dynamically scheduled jobs in the future - that are all able to survive application restarts, then an externally backed queueing library such as Exq could be a good fit.If you are starting a brand new project, I would also take a look at Faktory. It provides language independent queueing system, which means this logic doesn't have to be implemented across different languages and can use a thin client such as faktory_worker_ex.","ref":"readme.html","title":"Exq","type":"extras"},{"doc":"Pre-requisiteThis assumes you have an instance of Redis to use. The easiest way to install it on OSX is via brew:&gt; brew install redisTo start it:&gt; redis-serverScreencast on elixircasts.io:If you prefer video instructions, check out the screencast on elixircasts.io which details how to install and use the Exq library: https://elixircasts.io/elixir-job-processing-with-exqInstallationAdd :exq to your mix.exs deps (replace version with the latest hex.pm package version):defp deps do [ # ... other deps {:exq, &quot;~&gt; 0.16.0&quot;} ] endThen run mix deps.get.ConfigurationBy default, Exq will use configuration from your config.exs file. You can use this to configure your Redis host, port, password, as well as namespace (which helps isolate the data in Redis). If you would like to specify your options as a Redis URL, that is also an option using the url config key (in which case you would not need to pass the other Redis options).Configuration options may optionally be given in the {:system, &quot;VARNAME&quot;} format, which will resolve to the runtime environment value.Other options include:The queues list specifies which queues Exq will listen to for new jobs.The concurrency setting will let you configure the amount of concurrent workers that will be allowed, or :infinite to disable any throttling.The name option allows you to customize Exq's registered name, similar to using Exq.start_link([name: Name]). The default is Exq.If the option start_on_application is false, Exq won't be started automatically when booting up you Application. You can start it with Exq.start_link/1.The shutdown_timeout is the number of milliseconds to wait for workers to finish processing jobs when the application is shutting down. It defaults to 5000 ms.The mode option can be used to control what components of Exq are started. This would be useful if you want to only enqueue jobs in one node and run the workers in different node.:default - starts worker, enqueuer and API.:enqueuer - starts only the enqueuer.:api - starts only the api.[:api, :enqueuer] - starts both enqueuer and api.The backoff option allows you to customize the backoff time used for retry when a job fails. By default exponential time scaled based on job's retry_count is used. To change the default behavior, create a new module which implements the Exq.Backoff.Behaviour and set backoff option value to the module name.config :exq, name: Exq, host: &quot;127.0.0.1&quot;, port: 6379, password: &quot;optional_redis_auth&quot;, namespace: &quot;exq&quot;, concurrency: :infinite, queues: [&quot;default&quot;], poll_timeout: 50, scheduler_poll_timeout: 200, scheduler_enable: true, max_retries: 25, mode: :default, shutdown_timeout: 5000ConcurrencyExq supports concurrency setting per queue. You can specify the same concurrency option to apply to each queue or specify it based on a per queue basis.Concurrency for each queue will be set at 1000:config :exq, host: &quot;127.0.0.1&quot;, port: 6379, namespace: &quot;exq&quot;, concurrency: 1000, queues: [&quot;default&quot;]Concurrency for q1 is set at 10_000 while q2 is set at 10:config :exq, host: &quot;127.0.0.1&quot;, port: 6379, namespace: &quot;exq&quot;, queues: [{&quot;q1&quot;, 10_000}, {&quot;q2&quot;, 10}]Job RetriesExq will automatically retry failed job. It will use an exponential backoff timing similar to Sidekiq or delayed_job to retry failed jobs. It can be configured via these settings:config :exq, host: &quot;127.0.0.1&quot;, port: 6379, ... scheduler_enable: true, max_retries: 25Note that scheduler_enable has to be set to true and max_retries should be greater than 0.Dead JobsAny job that has failed more than max_retries times will be moved to dead jobs queue. Dead jobs could be manually re-enqueued via Sidekiq UI. Max size and timeout of dead jobs queue can be configured via these settings:config :exq, dead_max_jobs: 10_000, dead_timeout_in_seconds: 180 * 24 * 60 * 60, # 6 monthsOTP ApplicationYou can add Exq into your OTP application list, and it will start an instance of Exq along with your application startup. It will use the configuration from your config.exs file.def application do [ applications: [:logger, :exq], #other stuff... ] endWhen using Exq through OTP, it will register a process under the name Elixir.Exq - you can use this atom where expecting a process name in the Exq module.If you would like to control Exq startup, you can configure Exq to not start anything on application start. For example, if you are using Exq along with Phoenix, and your workers are accessing the database or other resources, it is recommended to disable Exq startup and manually add it to the supervision tree.This can be done by setting start_on_application to false and adding it to your supervision tree:config :exq, start_on_application: falsedef start(_type, _args) do children = [ # Start the Ecto repository MyApp.Repo, # Start the endpoint when the application starts MyApp.Endpoint, # Start the EXQ supervisor Exq, ]SentinelExq uses Redix client for communication with redis server. The client can be configured to use sentinel via redis_options. Note: you need to have Redix 0.9.0+.config :exq redis_options: [ sentinel: [sentinels: [[host: &quot;127.0.0.1&quot;, port: 6666]], group: &quot;exq&quot;], database: 0, password: nil, timeout: 5000, name: Exq.Redis.Client, socket_opts: [] ]","ref":"readme.html#getting-started","title":"Exq - Getting Started","type":"extras"},{"doc":"If you'd like to try Exq out on the iex console, you can do this by typing:&gt; mix deps.getand then:&gt; iex -S mixStandalone ExqYou can run Exq standalone from the command line, to run it:&gt; mix do app.start, exq.run","ref":"readme.html#using-iex","title":"Exq - Using IEx","type":"extras"},{"doc":"Enqueuing jobs:To enqueue jobs:{:ok, ack} = Exq.enqueue(Exq, &quot;default&quot;, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;]) {:ok, ack} = Exq.enqueue(Exq, &quot;default&quot;, &quot;MyWorker&quot;, [&quot;arg1&quot;, &quot;arg2&quot;]) ## Don&#39;t retry job in per worker {:ok, ack} = Exq.enqueue(Exq, &quot;default&quot;, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;], max_retries: 0) ## max_retries = 10, it will override :max_retries in config {:ok, ack} = Exq.enqueue(Exq, &quot;default&quot;, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;], max_retries: 10) In this example, &quot;arg1&quot; will get passed as the first argument to the perform method in your worker, &quot;arg2&quot; will be second argument, etc.You can also enqueue jobs without starting workers:{:ok, sup} = Exq.Enqueuer.start_link([port: 6379]) {:ok, ack} = Exq.Enqueuer.enqueue(Exq.Enqueuer, &quot;default&quot;, MyWorker, [])You can also schedule jobs to start at a future time. You need to make sure scheduler_enable is set to true.Schedule a job to start in 5 mins:{:ok, ack} = Exq.enqueue_in(Exq, &quot;default&quot;, 300, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;]) # If using `mode: [:enqueuer]` {:ok, ack} = Exq.Enqueuer.enqueue_in(Exq.Enqueuer, &quot;default&quot;, 300, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;])Schedule a job to start at 8am 2015-12-25 UTC:time = Timex.now() |&gt; Timex.shift(days: 8) {:ok, ack} = Exq.enqueue_at(Exq, &quot;default&quot;, time, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;]) # If using `mode: [:enqueuer]` {:ok, ack} = Exq.Enqueuer.enqueue_at(Exq.Enqueuer, &quot;default&quot;, time, MyWorker, [&quot;arg1&quot;, &quot;arg2&quot;])Creating WorkersTo create a worker, create an elixir module matching the worker name that will be enqueued. To process a job with &quot;MyWorker&quot;, create a MyWorker module. Note that the perform also needs to match the number of arguments as well.Here is an example of a worker:defmodule MyWorker do def perform do end endWe could enqueue a job to this worker:{:ok, jid} = Exq.enqueue(Exq, &quot;default&quot;, MyWorker, [])The 'perform' method will be called with matching args. For example:{:ok, jid} = Exq.enqueue(Exq, &quot;default&quot;, &quot;MyWorker&quot;, [arg1, arg2])Would match:defmodule MyWorker do def perform(arg1, arg2) do end endJob data from workerIf you'd like to get Job metadata information from a worker, you can call worker_job from within the worker:defmodule MyWorker do def perform(arg1, arg2) do # get job metadata job = Exq.worker_job() end endDynamic queue subscriptionsThe list of queues that are being monitored by Exq is determined by the config.exs file or the parameters passed to Exq.start_link. However, we can also dynamically add and remove queue subscriptions after Exq has started.To subscribe to a new queue:# last arg is optional and is the max concurrency for the queue :ok = Exq.subscribe(Exq, &quot;new_queue_name&quot;, 10)To unsubscribe from a queue::ok = Exq.unsubscribe(Exq, &quot;queue_to_unsubscribe&quot;)To unsubscribe from all queues::ok = Exq.unsubscribe_all(Exq)","ref":"readme.html#workers","title":"Exq - Workers","type":"extras"},{"doc":"If you'd like to customize worker execution and/or create plugins like Sidekiq/Resque have, Exq supports custom middleware. The first step would be to define the middleware in config.exs and add your middleware into the chain:middleware: [Exq.Middleware.Stats, Exq.Middleware.Job, Exq.Middleware.Manager, Exq.Middleware.Logger]You can then create a module that implements the middleware behavior and defines before_work, after_processed_work and after_failed_work functions. You can also halt execution of the chain as well. For a simple example of middleware implementation, see the Exq Logger Middleware.","ref":"readme.html#middleware-support","title":"Exq - Middleware Support","type":"extras"},{"doc":"If you would like to use Exq alongside Phoenix and Ecto, add :exq to your mix.exs application list:def application do [ mod: {Chat, []}, applications: [:phoenix, :phoenix_html, :cowboy, :logger, :exq] ] endAssuming you will be accessing the database from Exq workers, you will want to lower the concurrency level for those workers, as they are using a finite pool of connections and can potentially back up and time out. You can lower this through the concurrency setting, or perhaps use a different queue for database workers that have a lower concurrency just for that queue. Inside your worker, you would then be able to use the Repo to work with the database:defmodule Worker do def perform do HelloPhoenix.Repo.insert!(%HelloPhoenix.User{name: &quot;Hello&quot;, email: &quot;world@yours.com&quot;}) end end","ref":"readme.html#using-with-phoenix-and-ecto","title":"Exq - Using with Phoenix and Ecto","type":"extras"},{"doc":"To use alongside Sidekiq / Resque, make sure your namespaces as configured in Exq match the namespaces you are using in Sidekiq. By default, Exq will use the exq namespace, so you will have to change that.Another option is to modify Sidekiq to use the Exq namespace in the sidekiq initializer in your ruby project:Sidekiq.configure_server do |config| config.redis = { url: 'redis://127.0.0.1:6379', namespace: 'exq' } end Sidekiq.configure_client do |config| config.redis = { url: 'redis://127.0.0.1:6379', namespace: 'exq' } endFor an implementation example, see sineed's demo app illustrating Sidekiq to Exq communication.If you would like to exclusively send some jobs from Sidekiq to Exq as your migration strategy, you should create queue(s) that are exclusively listened to only in Exq (and configure those in the queue section in the Exq config). Make sure they are not configured to be listened to in Sidekiq, otherwise Sidekiq will also take jobs off that queue. You can still Enqueue jobs to that queue in Sidekiq even though they are not being monitored:Sidekiq::Client.push('queue' =&gt; 'elixir_queue', 'class' =&gt; 'ElixirWorker', 'args' =&gt; ['foo', 'bar'])","ref":"readme.html#using-alongside-sidekiq-resque","title":"Exq - Using alongside Sidekiq / Resque","type":"extras"},{"doc":"By default, your Redis server could be open to the world. As by default, Redis comes with no password authentication, and some hosting companies leave that port accessible to the world.. This means that anyone can read data on the queue as well as pass data in to be run. Obviously this is not desired, please secure your Redis installation by following guides such as the Digital Ocean Redis Security Guide.","ref":"readme.html#security","title":"Exq - Security","type":"extras"},{"doc":"A Node can be stopped unexpectedly while processing jobs due to various reasons like deployment, system crash, OOM, etc. This could leave the jobs in the in-progress state. Exq comes with two mechanisms to handle this situation.Same Node RecoveryExq identifies each node using an identifier. By default machine's hostname is used as the identifier. When a node comes back online after a crash, it will first check if there are any in-progress jobs for its identifier. Note that it will only re-enqueue jobs with the same identifier. There are environments like Heroku or Kubernetes where the hostname would change on each deployment. In those cases, the default identifier can be overriddenconfig :exq, node_identifier: MyApp.CustomNodeIdentifierdefmodule MyApp.CustomNodeIdentifier do @behaviour Exq.NodeIdentifier.Behaviour def node_id do # return node ID, perhaps from environment variable, etc System.get_env(&quot;NODE_ID&quot;) end endHeartbeatSame node recovery is straightforward and works well if the number of worker nodes is fixed. There are use cases that need the worker nodes to be autoscaled based on the workload. In those situations, a node that goes down might not come back for a very long period.Heartbeat mechanism helps in these cases. Each node registers a heartbeat at regular interval. If any node misses 5 consecutive heartbeats, it will be considered dead and all the in-progress jobs belong to that node will be re-enqueued.This feature is disabled by default and can be enabled using the following config:jconfig :exq, heartbeat_enable: true, heartbeat_interval: 60_000, missed_heartbeats_allowed: 5","ref":"readme.html#node-recovery","title":"Exq - Node Recovery","type":"extras"},{"doc":"Exq has a separate repo, exq_ui which provides with a Web UI to monitor your workers:See https://github.com/akira/exq_ui for more details.","ref":"readme.html#web-ui","title":"Exq - Web UI","type":"extras"},{"doc":"Typically, Exq will start as part of the application along with the configuration you have set. However, you can also start Exq manually and set your own configuration per instance.Here is an example of how to start Exq manually:{:ok, sup} = Exq.start_linkTo connect with custom configuration options (if you need multiple instances of Exq for example), you can pass in options under start_link:{:ok, sup} = Exq.start_link([host: &quot;127.0.0.1&quot;, port: 6379, namespace: &quot;x&quot;])By default, Exq will register itself under the Elixir.Exq atom. You can change this by passing in a name parameter:{:ok, exq} = Exq.start_link(name: Exq.Custom)","ref":"readme.html#starting-exq-manually","title":"Exq - Starting Exq manually","type":"extras"},{"doc":"Exq.Mock module provides few options to test your workers:# change queue_adapter in config/test.exs config :exq, queue_adapter: Exq.Adapters.Queue.Mock # start mock server in your test_helper.exs Exq.Mock.start_link(mode: :redis)Exq.Mock currently supports three modes. The default mode can provided on the Exq.Mock.start_link call. The mode could be overridden for each test by calling Exq.Mock.set_mode(:fake)redisThis could be used for integration testing. Doesn't support async: true option.fakeThe jobs get enqueued in a local queue and never get executed. Exq.Mock.jobs() returns all the jobs. Supports async: true option.inlineThe jobs get executed in the same process. Supports async: true option.","ref":"readme.html#testing","title":"Exq - Testing","type":"extras"},{"doc":"To donate, send to:Bitcoin (BTC): 17j52Veb8qRmVKVvTDijVtmRXvTUpsAWHv Ethereum (ETH): 0xA0add27EBdB4394E15b7d1F84D4173aDE1b5fBB3","ref":"readme.html#donation","title":"Exq - Donation","type":"extras"},{"doc":"For issues, please submit a Github issue with steps on how to reproduce the problem.","ref":"readme.html#questions-issues","title":"Exq - Questions?  Issues?","type":"extras"},{"doc":"Contributions are welcome. Tests are encouraged.To run tests / ensure your changes have not caused any regressions:mix test --no-startTo run the full suite, including failure conditions (can have some false negatives):mix test --trace --include failure_scenarios:true --no-start","ref":"readme.html#contributions","title":"Exq - Contributions","type":"extras"},{"doc":"Anantha Kumaran / @ananthakumaran (Lead)","ref":"readme.html#maintainers","title":"Exq - Maintainers","type":"extras"},{"doc":"Justin McNally (j-mcnally) (structtv), zhongwencool (zhongwencool), Joe Webb (ImJoeWebb), Chelsea Robb (chelsea), Nick Sanders (nicksanders), Nick Gal (nickgal), Ben Wilson (benwilson512), Mike Lawlor (disbelief), colbyh (colbyh), Udo Kramer (optikfluffel), Andreas Franzén (triptec),Josh Kalderimis (joshk), Daniel Perez (tuvistavie), Victor Rodrigues (rodrigues), Denis Tataurov (sineed), Joe Honzawa (Joe-noh), Aaron Jensen (aaronjensen), Andrew Vy (andrewvy), David Le (dl103), Roman Smirnov (romul), Thomas Athanas (typicalpixel), Wen Li (wli0503), Akshay (akki91), Rob Gilson (D1plo1d), edmz (edmz), and Benjamin Tan Wei Hao (benjamintanweihao).","ref":"readme.html#contributors","title":"Exq - Contributors","type":"extras"},{"doc":"Copyright (c) 2014 Alex KiraLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Exq - Copyright and License","type":"extras"}]